#include <vectrex.h>
#include "main.h"

#define ShopRepeatRate 3

long A; // AMOUNT SPENT ON ANIMALS
long B; // AMOUNT SPENT ON AMMUNITION
long C; // AMOUNT SPENT ON CLOTHING
long F; // AMOUNT SPENT ON FOOD
long M1; // AMOUNT SPENT ON MISCELLANEOUS SUPPLIES
long T; // CASH LEFT OVER AFTER INITIAL PURCHASES
long M; //TOTAL MILEAGE WHOLE TRIP
long M2; // MILEAGE UP THROUGH PREVIOUS TURN

unsigned int B1; //ACTUAL RESPONSE TIME FOR INPUTTING "BANG"

int E; //CHOICE OF EATING

int D9; //CHOICE OF SHOOTING EXPERTISE LEVEL

int X1; //FLAG FOR FORT OPTION
int S4; // FLAG FOR ILLNESS
int K8; // FLAG FOR INJURY
int F1; // FLAG FOR CLEARING SOUTH PASS
int F2; // FLAG FOR CLEARING BLUE MOUNTAINS
int M9; // FLAG FOR CLEARING SOUTH PASS IN SETTING MILEAGE
int L1; // FLAG FOR BLIZZARD
int C1; // FLAG FOR INSUFFICIENT CLOTHING IN COLD WEATHER

int D3; // TURN NUMBER FOR SETTING DATE

int S5; //HOSTILITY OF RIDERS FACTOR

char* daystr;

#define SMALL_FONTS

#ifdef SMALL_FONTS
#define Print_List syncPrintList
#define Print_Str_d syncPrintStrd
extern void syncPrintList(void* const u);
extern void syncPrintStrd(const int a, const int b, void* const u);
#define BOTTOM -123
#define SELECT_CHAR 0x3e
#else 
#define BOTTOM -128
#define SELECT_CHAR 0x69
#endif



void StartFrame()
{
	Wait_Recal();
	Intensity_7F();
	dp_VIA_t1_cnt_lo = 0x7f;
}

void Format3(char* pBuffer, long number)
{
	char h = (char)(number % 10);
	number /= 10;
	pBuffer[2] = '0' + h;

	if (number > 0)
	{
		h = (char)(number % 10);
		number /= 10;
		pBuffer[1] = '0' + h;
	}
	else
	{
		pBuffer[1] = ' ';
	}

	if (number > 0)
	{
		pBuffer[0] = '0' + (char)number;
	}
	else
	{
		pBuffer[0] = ' ';
	}
}

void Format4(char* pBuffer, long number)
{
	char h = (char)(number % 10);
	number /= 10;
	pBuffer[3] = '0' + h;

	if (number > 0)
	{
		h = (char)(number % 10);
		number /= 10;
		pBuffer[2] = '0' + h;
	}
	else
	{
		pBuffer[2] = ' ';
	}

	if (number > 0)
	{
		h = (char)(number % 10);
		number /= 10;
		pBuffer[1] = '0' + h;
	}
	else
	{
		pBuffer[1] = ' ';
	}

	if (number > 0)
	{
		pBuffer[0] = '0' + (char)number;
	}
	else
	{
		pBuffer[0] = ' ';
	}
}

void Format5(char* pBuffer, long number)
{
	char h = (char)(number % 10);
	number /= 10;
	pBuffer[4] = '0' + h;

	if (number > 0)
	{
		h = (char)(number % 10);
		number /= 10;
		pBuffer[3] = '0' + h;
	}
	else
	{
		pBuffer[3] = ' ';
	}

	if (number > 0)
	{
		h = (char)(number % 10);
		number /= 10;
		pBuffer[2] = '0' + h;
	}
	else
	{
		pBuffer[2] = ' ';
	}

	if (number > 0)
	{
		h = (char)(number % 10);
		number /= 10;
		pBuffer[1] = '0' + h;
	}
	else
	{
		pBuffer[1] = ' ';
	}

	if (number > 0)
	{
		pBuffer[0] = '0' + (char)number;
	}
	else
	{
		pBuffer[0] = ' ';
	}
}

void ShowMsgOK(char* msg)
{
	while (1)
	{
		StartFrame ();
		Print_Str_d(120, -60, daystr);

		Print_List(msg);

		Print_Str_d(BOTTOM, 90, "OK\x80");

		Read_Btns();

		if (Vec_Button_1_4 != 0)
		{
			return;
		}
	}
}

int ShowMsgYesNo(char* msg)
{
	while (1)
	{
		StartFrame ();
		Print_List(msg);

		Print_Str_d(BOTTOM, -120, "YES\x80");
		Print_Str_d(BOTTOM, 90, "NO\x80");

		Read_Btns();

		if (Vec_Button_1_1 != 0)
		{
			return 1;
		}

		if (Vec_Button_1_4 != 0)
		{
			return 0;
		}
	};
}

void Shooting(int offset, char* reasonStr)
{
	int frameCounter = 50;

	char startcounter[4] = { ' ', '5', ' ', 0x80 };

	char targets[9] = { '*', ' ', '*', ' ', '*', ' ', '*', 0x80 };
	char fire[9] = { ' ', ' ', ' ', ' ', ' ', ' ', ' ', 0x80 };

	unsigned int rnd = (unsigned int)Random();

	char selectedTargets[4];

	for (int i = 0; i < 4; i++)
	{
		selectedTargets[i] = '1' + (rnd & 0x3);
		rnd >>= 2;
	}

	while (1)
	{
		StartFrame ();
		Print_Str_d(120, -60, daystr);
		Print_Str_d(90, offset, reasonStr);

		Print_Str_d(20, -80, "PREPARE TO FIRE\x80");
		Print_Str_d(00, -22, startcounter);
		Print_Str_d(-20, -45, targets);

		frameCounter--;

		if (frameCounter == 0)
		{
			frameCounter = 50;

			startcounter[1]--;

			if (startcounter[1] == '0')
			{
				break;
			}
		}
	}

	int firecounter = 0;

	B1 = 0;
	frameCounter = 50;
	char next = 0;

	targets[0] = selectedTargets[0];

	while (1)
	{
		StartFrame ();

		frameCounter--;

		if (frameCounter == 0)
		{
			frameCounter = 50;

			B1++;
		}

		Print_Str_d(120, -60, daystr);
		Print_Str_d(90, offset, reasonStr);

		Print_Str_d(-20, -45, targets);
		Print_Str_d(-40, -45, fire);

		Read_Btns();

		if (Vec_Button_1_1 != 0)
		{
			next = '1';
		}

		if (Vec_Button_1_2 != 0)
		{
			next = '2';
		}

		if (Vec_Button_1_3 != 0)
		{
			next = '3';
		}

		if (Vec_Button_1_4 != 0)
		{
			next = '4';
		}

		if (next != 0)
		{
			if (next != selectedTargets[firecounter])
			{
				B1 = 100;
				return;
			}

			fire[firecounter * 2] = next;

			firecounter++;

			if (firecounter == 4)
			{
				if (B1 < (unsigned int)D9)
				{
					B1 = 0;
				}
				else
				{
					B1 -= (unsigned int)D9;
				}

				return;
			}

			targets[firecounter * 2] = selectedTargets[firecounter];

			next = 0;
		}
	}
}

int InstructionQuestion()
{
	char* msgData =
		"\x41\xA0""DO YOU NEED\x80"\
		"\x31\xA0""INSTRUCTIONS?\x80\x00";

	return ShowMsgYesNo(msgData);
}

static const char* instructionPages[] =
{
	"\x41\xA0""THIS PROGRAM\x80"\
	"\x31\xA0""SIMULATES A TRIP\x80"\
	"\x21\xA0""OVER THE OREGON\x80"\
	"\x11\xA0""TRAIL FROM\x80"\
	"\x01\xA0""INDEPENDENCE,\x80"\
	"\xF1\xA0""MISSOURI TO OREGON\x80"\
	"\xE1\xA0""CITY, OREGON\x80"\
	"\xD1\xA0""IN 1847.\x80\x00",
			 
	"\x41\xA0""YOUR FAMILY OF\x80"\
	"\x31\xA0""FIVE WILL COVER\x80"\
	"\x21\xA0""THE 2040 MILE\x80"\
	"\x11\xA0""OREGON TRAIL\x80"\
	"\x01\xA0""IN 5-6 MONTHS\x80"\
	"\xE1\xA0""IF YOU MAKE\x80"\
	"\xD1\xA0""IT ALIVE.\x80\x00",

	"\x41\xA0""YOU HAD SAVED $900\x80"\
	"\x31\xA0""TO SPEND FOR THE\x80"\
	"\x21\xA0""TRIP, AND YOU\x80"\
	"\x11\xA0""HAVE JUST PAID\x80"\
	"\x01\xA0""$200 FOR A WAGON.\x80\x00",

	"\x41\xA0""YOU WILL NEED TO\x80"\
	"\x31\xA0""SPEND THE REST OF\x80"\
	"\x21\xA0""YOUR MONEY ON THE\x80"\
	"\x11\xA0""FOLLOWING ITEMS:\x80\x00",

	"\x41\xA0""OXEN:\x80"\
	"\x21\xA0""YOU CAN SPEND\x80"\
	"\x11\xA0""$200-$300 ON YOUR\x80"\
	"\x01\xA0""TEAM THE MORE YOU\x80"\
	"\xF1\xA0""SPEND, THE FASTER\x80"\
	"\xE1\xA0""YOU WILL GO\x80"\
	"\xD1\xA0""BECAUSE YOU WILL\x80"\
	"\xC1\xA0""HAVE BETTER\x80"\
	"\xB1\xA0""ANIMALS\x80\x00",

	"\x41\xA0""FOOD:\x80"\
	"\x21\xA0""THE MORE YOU HAVE,\x80"\
	"\x11\xA0""THE LESS CHANCE\x80"\
	"\x01\xA0""THERE IS OF\x80"\
	"\xF1\xA0""GETTING SICK\x80\x00",

	"\x41\xA0""AMMUNITION:\x80"\
	"\x21\xA0""$1 BUYS A BELT OF\x80"\
	"\x11\xA0""50 BULLETS YOU\x80"\
	"\x01\xA0""WILL NEED BULLETS\x80"\
	"\xF1\xA0""FOR ATTACKS BY\x80"\
	"\xE1\xA0""ANIMALS AND\x80"\
	"\xD1\xA0""BANDITS, AND FOR\x80"\
	"\xC1\xA0""HUNTING FOOD\x80\x00",

	"\x41\xA0""CLOTHING:\x80"\
	"\x21\xA0""THIS IS ESPECIALLY\x80"\
	"\x11\xA0""IMPORTANT FOR THE\x80"\
	"\x01\xA0""COLD WEATHER YOU\x80"\
	"\xF1\xA0""WILL ENCOUNTER\x80"\
	"\xE1\xA0""WHEN CROSSING\x80"\
	"\xD1\xA0""THE MOUNTAINS\x80\x00",

	"\x41\xA0""MISCELLANEOUS\x80"\
	"\x31\xA0""SUPPLIES:\x80"\
	"\x11\xA0""THIS INCLUDES\x80"\
	"\x01\xA0""MEDICINE AND OTHER\x80"\
	"\xF1\xA0""THINGS YOU WILL\x80"\
	"\xE1\xA0""NEED FOR SICKNESS\x80"\
	"\xD1\xA0""AND EMERGENCY\x80"\
	"\xC1\xA0""REPAIRS\x80\x00",

	"\x41\xA0""YOU CAN SPEND ALL\x80"\
	"\x31\xA0""YOUR MONEY BEFORE\x80"\
	"\x21\xA0""YOU START YOUR\x80"\
	"\x11\xA0""TRIP OR YOU CAN\x80"\
	"\x01\xA0""SAVE SOME OF YOUR\x80"\
	"\xF1\xA0""CASH TO SPEND AT\x80"\
	"\xE1\xA0""FORTS ALONG THE\x80"\
	"\xD1\xA0""WAY WHEN YOU\x80"\
	"\xC1\xA0""RUN LOW.\x80\x00",

	"\x41\xA0""HOWEVER, ITEMS\x80"\
	"\x31\xA0""COST MORE AT THE\x80"\
	"\x21\xA0""FORTS. YOU CAN\x80"\
	"\x11\xA0""ALSO GO HUNTING\x80"\
	"\x01\xA0""ALONG THE WAY TO\x80"\
	"\xF1\xA0""GET MORE FOOD.\x80\x00",

	"\x41\xA0""WHENEVER YOU HAVE\x80"\
	"\x31\xA0""TO USE YOUR TRUSTY\x80"\
	"\x21\xA0""RIFLE ALONG THE\x80"\
	"\x11\xA0""WAY, YOU WILL BE\x80"\
	"\x01\xA0""TOLD 4 TIMES TO\x80"\
	"\xF1\xA0""HIT A SPECIFIC\x80"\
	"\xE1\xA0""CONTROLLER\x80"\
	"\xD1\xA0""BUTTON\x80\x00",

	"\x41\xA0""THE FASTER YOU\x80"\
	"\x31\xA0""PRESS THIS BUTTON,\x80"\
	"\x21\xA0""THE BETTER LUCK\x80"\
	"\x11\xA0""YOU WILL HAVE\x80"\
	"\x01\xA0""WITH YOUR GUN.\x80\x00",

	"\x41\xA0""AT EACH TURN, ALL\x80"\
	"\x31\xA0""ITEMS ARE SHOWN\x80"\
	"\x21\xA0""IN DOLLAR AMOUNTS\x80"\
	"\x11\xA0""EXCEPT BULLETS\x80\x00",

	"\x41\xA0""WHEN ASKED TO\x80"\
	"\x31\xA0""ENTER MONEY\x80"\
	"\x21\xA0""AMOUNTS, USE UP &\x80"\
	"\x11\xA0""DOWN TO SELECT THE\x80"\
	"\x01\xA0""ITEM. LEFT & RIGHT\x80"\
	"\xF1\xA0""TO CHANGE THE\x80"\
	"\xE1\xA0""AMOUNT.\x80"\
	"\xC1\xA0""GOOD LUCK\x80\x00"
};

void ShowInstruction()
{
	int currentPage = 0;
	int lastPage = (sizeof(instructionPages)/sizeof(char*)) - 1;

	while (1)
	{
		StartFrame ();

		char* data = (char*)instructionPages[currentPage];
		Print_List(data);

		if (currentPage > 0)
		{
			Print_Str_d(BOTTOM, -120, "PREV\x80");
			Print_Str_d(BOTTOM, -60, "TOP\x80");
		}

		if (currentPage < lastPage)
		{
			Print_Str_d(BOTTOM, 0, "BOTT\x80");
			Print_Str_d(BOTTOM, 60, "NEXT\x80");
		}
		else
		{
			Print_Str_d(BOTTOM, 60, "PLAY\x80");
		}

		Read_Btns();

		if (currentPage > 0 && Vec_Button_1_1 != 0)
		{
			currentPage--;
		}
		else if (currentPage > 0 && Vec_Button_1_2 != 0)
		{
			currentPage = 0;
		}
		else if (currentPage < lastPage && Vec_Button_1_3 != 0)
		{
			currentPage = lastPage;
		}
		else if (Vec_Button_1_4 != 0)
		{
			if (currentPage == lastPage)
			{
				return;
			}
			else
			{
				currentPage++;
			}
		}
	};
}

int SelectLevel()
{
	int level = 5;

	while (1)
	{
		StartFrame ();
		Print_Str_d(60, -110, "HOW GOOD A SHOT ARE\x80");
		Print_Str_d(40, -110, "YOU WITH YOUR RIFLE?\x80");

		switch (level)
		{
		case 1:
			Print_Str_d(-30, -90, "  ACE MARKSMAN   \x80");
			break;
		case 2:
			Print_Str_d(-30, -90, "    GOOD SHOT     \x80");
			break;
		case 3:
			Print_Str_d(-30, -90, " FAIR TO MIDDLIN  \x80");
			break;
		case 4:
			Print_Str_d(-30, -90, "NEED MORE PRACTICE\x80");
			break;
		case 5:
			Print_Str_d(-30, -90, "   SHAKY KNEES    \x80");
			break;
		}

		/*
		740  PRINT "ENTER ONE OF THE ABOVE . THE BETTER YOU CLAIM YOU ARE, THE"
		750  PRINT "FASTER YOU'LL HAVE TO BE WITH YOUR GUN TO BE SUCCESSFUL."
		*/

		Print_Str_d(BOTTOM, -120, " + \x80");
		Print_Str_d(BOTTOM, -60, " - \x80");

		Print_Str_d(BOTTOM, 90, "OK\x80");

		Read_Btns();

		if (Vec_Button_1_1 != 0)
		{
			if (level > 1)
			{
				level--;
			}
		}

		if (Vec_Button_1_2 != 0)
		{
			if (level < 5)
			{
				level++;
			}
		}

		if (Vec_Button_1_4 != 0)
		{
			return level;
		}
	};
}

void InitialPurchases()
{
	X1 = -1;
	M = 0;
	D3 = -1;
	K8 = 0;
	S4 = 0;
	F1 = 0;
	F2 = 0;
	M9 = 0;

	A = 200;
	F = 0;
	B = 0;
	C = 0;
	M1 = 0;

	T = 700 - A - F - B - C - M1;

	char cash[7] = { ' ','$', ' ', ' ', ' ', ' ', 0x80 };
	char oxen[7] = { SELECT_CHAR,'O', ' ', ' ', ' ', ' ', 0x80 };
	char food[7] = { ' ','F', ' ', ' ', ' ', ' ', 0x80 };
	char ammo[7] = { ' ','A', ' ',' ' , ' ', ' ', 0x80 };
	char cloth[7] = { ' ','C', ' ', ' ', ' ', ' ', 0x80 };
	char supp[7] = { ' ','S', ' ', ' ', ' ', ' ', 0x80 };

	Format3(&cash[3], T);
	Format3(&oxen[3], A);
	Format3(&food[3], F);
	Format3(&ammo[3], B);
	Format3(&cloth[3], C);
	Format3(&supp[3], M1);

	int select = 0;
	char* selectedText = oxen;
	long* selectedValue = &A;

	int updateSelect = 0;
	int canSelect = 0;
	int repeatCounter = 0;

	long maxValue = 300;
	long minValue = 200;

	while (1)
	{
		updateSelect = 0;

		StartFrame ();
		Print_Str_d(110, -100, "SPEND YOUR MONEY\x80");
		Print_Str_d(70, -100, cash);
		Print_Str_d(30, -100, oxen);
		Print_Str_d(10, -100, food);
		Print_Str_d(-10, -100, ammo);
		Print_Str_d(-30, -100, cloth);
		Print_Str_d(-50, -100, supp);

		Print_Str_d(BOTTOM, 90, "OK\x80");

		Read_Btns();

		if (Vec_Button_1_4 != 0)
		{
			break;
		}

		Joy_Digital();

		if (repeatCounter > 0)
		{
			repeatCounter--;
		}
		else
		{
			if (T > 0 && Vec_Joy_1_X > 0 && *selectedValue < maxValue)
			{
				*selectedValue = *selectedValue + 1;
				T--;

				Format3(&cash[3], T);
				Format3(&selectedText[3], *selectedValue);

				repeatCounter = ShopRepeatRate;
			}
			else if (Vec_Joy_1_X < 0 && *selectedValue > minValue)
			{
				*selectedValue = *selectedValue - 1;
				T++;

				Format3(&cash[3], T);
				Format3(&selectedText[3], *selectedValue);

				repeatCounter = ShopRepeatRate;
			}
		}

		if (Vec_Joy_1_X == 0)
		{
			repeatCounter = 0;
		}

		if (canSelect)
		{
			if (Vec_Joy_1_Y > 0)
			{
				select--;

				if (select < 0)
				{
					select = 4;
				}

				updateSelect = 1;
			}
			else if (Vec_Joy_1_Y < 0)
			{
				select++;

				if (select > 4)
				{
					select = 0;
				}

				updateSelect = 1;
			}
		}

		if (Vec_Joy_1_Y == 0)
		{
			canSelect = 1;
		}

		if (updateSelect)
		{
			*selectedText = ' ';

			switch (select)
			{
			case 0:
				selectedText = oxen;
				selectedValue = &A;
				minValue = 200;
				maxValue = 300;
				break;
			case 1:
				selectedText = food;
				selectedValue = &F;
				minValue = 0;
				maxValue = 999;
				break;
			case 2:
				selectedText = ammo;
				selectedValue = &B;
				minValue = 0;
				maxValue = 999;
				break;
			case 3:
				selectedText = cloth;
				selectedValue = &C;
				minValue = 0;
				maxValue = 999;
				break;
			case 4:
				selectedText = supp;
				selectedValue = &M1;
				minValue = 0;
				maxValue = 999;
				break;
			}

			*selectedText = SELECT_CHAR;

			canSelect = 0;
		}
	};

	B *= 50;
}

int SetDayString()
{
	D3++;

	switch (D3)
	{
	case 0: daystr = "MON MAR 29 1847\x80"; break;
	case 1: daystr = "MON APR 12 1847\x80"; break;
	case 2: daystr = "MON APR 26 1847\x80"; break;
	case 3: daystr = "MON MAY 10 1847\x80"; break;
	case 4: daystr = "MON MAY 24 1847\x80"; break;
	case 5: daystr = "MON JUN  7 1847\x80"; break;
	case 6: daystr = "MON JUN 21 1847\x80"; break;
	case 7: daystr = "MON JUL  5 1847\x80"; break;
	case 8: daystr = "MON JUL 19 1847\x80"; break;
	case 9: daystr = "MON AUG  2 1847\x80"; break;
	case 10: daystr = "MON AUG 16 1847\x80"; break;
	case 11: daystr = "MON AUG 31 1847\x80"; break;
	case 12: daystr = "MON SEP 13 1847\x80"; break;
	case 13: daystr = "MON SEP 27 1847\x80"; break;
	case 14: daystr = "MON OCT 11 1847\x80"; break;
	case 15: daystr = "MON OCT 25 1847\x80"; break;
	case 16: daystr = "MON NOV  8 1847\x80"; break;
	case 17: daystr = "MON NOV 22 1847\x80"; break;
	case 18: daystr = "MON DEC  6 1847\x80"; break;
	case 19: daystr = "MON DEC 20 1847\x80"; break;
	default: return 0;
	}

	return 1;
}

int StartTurn()
{
	if (F < 0)
	{
		F = 0;
	}

	if (B < 0)
	{
		B = 0;
	}

	if (C < 0)
	{
		C = 0;
	}

	if (M1 < 0)
	{
		M1 = 0;
	}

	if (F < 13)
	{
		char* msgData =
			"\x41\xA0""YOU WOULD BETTER\x80"\
			"\x31\xA0""DO SOME HUNTING\x80"\
			"\x21\xA0""OR BUY FOOD AND\x80"\
			"\x11\xA0""SOON\x80\x00";

		ShowMsgOK(msgData);
	}

	M2 = M;

	if (S4 || K8)
	{
		T -= 20;

		if (T < 0)
		{
			return -1;
		}

		char* msgData =
			"\x41\xA0""DOCTOR\x80"\
			"\x31\xA0""BILL IS $20\x80\x00";

		ShowMsgOK(msgData);

		K8 = 0;
		S4 = 0;
	}

	/*
	2230  IF B>39 THEN 2260
	2240  PRINT "TOUGH---YOU NEED MORE BULLETS TO GO HUNTING"
	*/

	int result = 0;

	char cash[6] = { '$', ' ', ' ', ' ', ' ', 0x80 };
	char oxen[6] = { 'O', ' ', ' ', ' ', ' ', 0x80 };
	char food[6] = { 'F', ' ', ' ', ' ', ' ', 0x80 };
	char ammo[8] = { 'A', ' ',' ',' ', ' ', ' ', ' ', 0x80 };
	char cloth[6] = { 'C', ' ', ' ', ' ', ' ', 0x80 };
	char supp[6] = { 'S', ' ', ' ', ' ', ' ', 0x80 };
	char miles[7] = { 'M', ' ', ' ', ' ', ' ', ' ', 0x80 };

	Format3(&cash[2], T);
	Format3(&oxen[2], A);
	Format5(&ammo[2], B);
	Format3(&cloth[2], C);
	Format3(&supp[2], M1);
	Format3(&food[2], F);

	if (M9 == 1)
	{
		Format4(&miles[2], 950);
		M9 = 0;
	}
	else
	{
		Format4(&miles[2], M);
	}

	while (1)
	{
		StartFrame ();
		Print_Str_d(120, -60, daystr);
		Print_Str_d(70, -100, cash);
		Print_Str_d(30, -100, oxen);
		Print_Str_d(10, -100, food);
		Print_Str_d(-10, -100, ammo);
		Print_Str_d(-30, -100, cloth);
		Print_Str_d(-50, -100, supp);
		Print_Str_d(-90, -100, miles);

		if (X1 > 0)
		{
			Print_Str_d(BOTTOM, -120, "FORT\x80");
		}

		if (B > 39)
		{
			Print_Str_d(BOTTOM, -60, "HUNT\x80");
		}

		Print_Str_d(BOTTOM, 70, "CONT\x80");

		Read_Btns();

		if (X1 > 0 && Vec_Button_1_1 != 0)
		{
			result = 1;
			break;
		}

		if (B > 39 && Vec_Button_1_2 != 0)
		{
			result = 2;
			break;
		}

		if (Vec_Button_1_4 != 0)
		{
			result = 3;
			break;
		}
	};

	X1 = X1 * (-1);

	return result;
}

void StoppingAtFort()
{
	long buyFood = 0;
	long buyAmmo = 0;
	long buyCloth = 0;
	long buySupp = 0;

	char cash[7] = { ' ','$', ' ', ' ', ' ', ' ', 0x80 };
	char food[7] = { SELECT_CHAR,'F', ' ', ' ', ' ', '0', 0x80 };
	char ammo[7] = { ' ','A', ' ',' ' , ' ', '0', 0x80 };
	char cloth[7] = { ' ','C', ' ', ' ', ' ', '0', 0x80 };
	char supp[7] = { ' ','S', ' ', ' ', ' ', '0', 0x80 };

	Format3(&cash[3], T);

	int select = 0;
	char* selectedText = food;
	long* selectedValue = &buyFood;

	int updateSelect = 0;
	int canSelect = 0;
	int repeatCounter = 0;

	while (1)
	{
		updateSelect = 0;

		StartFrame ();
		Print_Str_d(110, -100, "FORT STORE\x80");
		Print_Str_d(70, -100, cash);
		Print_Str_d(10, -100, food);
		Print_Str_d(-10, -100, ammo);
		Print_Str_d(-30, -100, cloth);
		Print_Str_d(-50, -100, supp);

		Print_Str_d(BOTTOM, 90, "OK\x80");

		Read_Btns();

		if (Vec_Button_1_4 != 0)
		{
			break;
		}

		Joy_Digital();

		if (repeatCounter > 0)
		{
			repeatCounter--;
		}
		else
		{
			if (T > 0 && Vec_Joy_1_X > 0)
			{
				*selectedValue = *selectedValue + 1;
				T--;

				Format3(&cash[3], T);
				Format3(&selectedText[3], *selectedValue);

				repeatCounter = ShopRepeatRate;
			}
			else if (Vec_Joy_1_X < 0 && *selectedValue > 0)
			{
				*selectedValue = *selectedValue - 1;
				T++;

				Format3(&cash[3], T);
				Format3(&selectedText[3], *selectedValue);

				repeatCounter = ShopRepeatRate;
			}
		}

		if (Vec_Joy_1_X == 0)
		{
			repeatCounter = 0;
		}


		if (canSelect)
		{
			if (Vec_Joy_1_Y > 0)
			{
				select--;

				if (select < 0)
				{
					select = 3;
				}

				updateSelect = 1;
			}
			else if (Vec_Joy_1_Y < 0)
			{
				select++;

				if (select > 3)
				{
					select = 0;
				}

				updateSelect = 1;
			}
		}

		if (Vec_Joy_1_Y == 0)
		{
			canSelect = 1;
		}

		if (updateSelect)
		{
			*selectedText = ' ';

			switch (select)
			{
			case 0:
				selectedText = food;
				selectedValue = &buyFood;
				break;
			case 1:
				selectedText = ammo;
				selectedValue = &buyAmmo;
				break;
			case 2:
				selectedText = cloth;
				selectedValue = &buyCloth;
				break;
			case 3:
				selectedText = supp;
				selectedValue = &buySupp;
				break;
			}

			*selectedText = SELECT_CHAR;

			canSelect = 0;
		}
	};

	F += buyFood * 2 / 3;
	B += buyAmmo * 2 * 50 / 3;
	C += buyCloth * 2 / 3;
	M1 += buySupp * 2 / 3;

	M = M - 45;
}

void Hunting()
{
	M -= 45;

	Shooting (-40, "HUNTING\x80");
	
	char* msgData;

	if (B1 <= 1)
	{
		msgData =
			"\x41\xA0""RIGHT BETWEEN THE\x80"\
			"\x31\xA0""EYES. YOU GOT A\x80"\
			"\x21\xA0""BIG ONE. FULL\x80"\
			"\x11\xA0""BELLIES TONIGHT\x80\x00";

		F += 52 + (((unsigned int)Random()) % 6);
		B -= (10 + (((unsigned int)Random()) % 4));
	}
	else if (B1 <= 7 && ((unsigned int)Random()) > 33 * B1)
	{
		msgData =
			"\x41\xA0""NICE SHOT. RIGHT\x80"\
			"\x31\xA0""ON TARGET. GOOD\x80"\
			"\x21\xA0""EATING TONIGHT\x80\x00";

		F += 48 - +2 * B1;
		B -= (10 + 3 * B1);
	}
	else
	{
		msgData =
			"\x41\xA0""YOU MISSED\x80"\
			"\x31\xA0""AND YOUR DINNER\x80"\
			"\x21\xA0""GOT AWAY.....\x80\x00";

		// No Bullets used in original code. Might be a bug
	}

	ShowMsgOK(msgData);
}

void Eating()
{
	char* msgData =
		"\x41\xA0""HOW DO YOU\x80"\
		"\x31\xA0""WANT TO EAT ?\x80\x00";

	while (1)
	{
		StartFrame ();
		Print_Str_d(120, -60, daystr);
		Print_List(msgData);

		Print_Str_d(BOTTOM, -120, "POOR\x80");

		if (F >= 18)
		{
			Print_Str_d(BOTTOM, -60, "MOD\x80");
		}

		if (F >= 23)
		{
			Print_Str_d(BOTTOM, 0, "WELL\x80");
		}

		Read_Btns();

		if (Vec_Button_1_1 != 0)
		{
			E = 1;
			F -= 13;
			break;
		}

		if (Vec_Button_1_2 != 0)
		{
			E = 2;
			F -= 18;
			break;
		}

		if (Vec_Button_1_3 != 0)
		{
			E = 3;
			F -= 23;
			break;
		}
	};
}

void RidersCombatDone()
{
	char* msgData;

	if (B1 <= 1)
	{
		msgData =
			"\x41\xA0""NICE SHOOTING\x80"\
			"\x31\xA0""YOU DROVE THEM\x80"\
			"\x21\xA0""OFF\x80\x00";
	}
	else if (B1 > 4)
	{
		K8 = 1;

		msgData =
			"\x41\xA0""LOUSY SHOT\x80"\
			"\x31\xA0""YOU GOT KNIFED\x80"\
			"\x21\xA0""YOU HAVE TO SEE\x80"\
			"\x11\xA0""OLD DOC BLANCHARD\x80\x00";
	}
	else
	{
		msgData =
			"\x41\xA0""KINDA SLOW WITH\x80"\
			"\x31\xA0""YOUR COLT .45\x80\x00";
	}

	ShowMsgOK(msgData);
}

int RidersAttack()
{
	if (M <= 400)
	{
		if (((unsigned int)Random()) > 48 + M / 5)
		{
			return 0;
		}
	}
	else
	{
		if (((unsigned int)Random()) > 128 - (M - 400) / 21)
		{
			return 0;
		}
	}

	char* msgData;

	if (((unsigned int)Random()) < 204)
	{
		S5 = 0;

		msgData =
			"\x41\xA0""RIDERS AHEAD.\x80"\
			"\x21\xA0""THEY \x80"\
			"\x11\xA0""LOOK HOSTILE\x80"\
			"\xE1\xA0""TACTICS?\x80\x00";
	}
	else
	{
		S5 = 1;

		msgData =
			"\x41\xA0""RIDERS AHEAD.\x80"\
			"\x21\xA0""THEY DO NOT\x80"\
			"\x11\xA0""LOOK HOSTILE\x80"\
			"\xE1\xA0""TACTICS?\x80\x00";
	}

	int tactic;

	while (1)
	{
		StartFrame ();
		Print_Str_d(120, -60, daystr);
		Print_List(msgData);

		Print_Str_d(BOTTOM, -120, "RUN\x80");
		Print_Str_d(BOTTOM, -60, "ATTA\x80");
		Print_Str_d(BOTTOM, 0, "CONT\x80");
		Print_Str_d(BOTTOM, 60, "CIRC\x80");

		Read_Btns();

		if (Vec_Button_1_1 != 0)
		{
			tactic = 1;
			break;
		}

		if (Vec_Button_1_2 != 0)
		{
			tactic = 2;
			break;
		}

		if (Vec_Button_1_3 != 0)
		{
			tactic = 3;
			break;
		}

		if (Vec_Button_1_4 != 0)
		{
			tactic = 4;
			break;
		}
	};

	if (((unsigned int)Random()) <= 61)
	{
		S5 = 1 - S5;
	}

	if (S5 == 1)
	{
		switch (tactic)
		{
		case 1:
			M += 15;
			A -= 10;
			break;

		case 2:
			M -= 5;
			B -= 100;

		case 3:
			break;

		case 4:
			M -= 20;
			break;
		}
	}
	else
	{
		switch (tactic)
		{
		case 1:
			M += 20;
			M1 -= 15;
			B -= 150;
			A -= 40;
			break;

		case 2:
			Shooting(-70, "RIDERS AHEAD\x80");
			B -= (long)B1 * 40 + 80;
			RidersCombatDone();
			break;
		case 3:
			if (((unsigned int)Random()) > 204)
			{
				msgData =
					"\x41\xA0""THEY DID NOT\x80"\
					"\x31\xA0""ATTACK\x80\x00";

				ShowMsgOK(msgData);
				return 0;
			}

			B -= 150;
			M1 -= 15;
			break;

		case 4:
			Shooting(-70, "RIDERS AHEAD\x80");
			B -= (long)B1 * 30 + 80;
			M -= 25;
			RidersCombatDone();
			break;
		}
	}

	if (S5 != 0)
	{
		msgData =
			"\x41\xA0""RIDERS WERE\x80"\
			"\x31\xA0""FRIENDLY, BUT\x80"\
			"\x21\xA0""CHECK FOR\x80"\
			"\x11\xA0""POSSIBLE LOSSES\x80\x00";

		ShowMsgOK(msgData);

		return 0;
	}

	msgData =
		"\x41\xA0""RIDERS WERE\x80"\
		"\x31\xA0""HOSTILE\x80"\
		"\x21\xA0""CHECK FOR\x80"\
		"\x11\xA0""LOSSES\x80\x00";

	ShowMsgOK(msgData);

	if (B < 0)
	{
		return -7;
	}

	return 0;
}

int IllnessEvent()
{
	char* msgData;

	if (((((unsigned int)Random()) % 100)) < 10 + 35 * (unsigned int)(E - 1))
	{
		msgData =
			"\x41\xA0""MILD ILLNESS\x80"\
			"\x21\xA0""MEDICINE USED\x80\x00";

		M -= 5;
		M1 -= 2;
	}
	else
	{
		if (((((unsigned int)Random()) % 100)) < 100 - (40 / 4 * (unsigned int)(E - 1)))
		{
			msgData =
				"\x41\xA0""BAD ILLNESS\x80"\
				"\x21\xA0""MEDICINE USED\x80\x00";

			M -= 5;
			M1 -= 5;
		}
		else
		{
			msgData =
				"\x41\xA0""SERIOUS ILLNESS\x80"\
				"\x21\xA0""YOU MUST STOP FOR\x80"\
				"\x11\xA0""MEDICAL ATTENTION\x80\x00";

			M1 -= 10;
			S4 = 1;
		}
	}

	ShowMsgOK(msgData);

	if (M1 < 0)
	{
		return -3;
	}

	return 0;
}

int ColdWeatherEvent()
{
	char* msgData;

	if (C > 22 + (((unsigned int)Random()) % 4))
	{
		msgData =
			"\x41\xA0""COLD WEATHER\x80"\
			"\x21\xA0""BRRRRRR\x80"\
			"\x01\xA0""YOU HAVE ENOUGH\x80"\
			"\xF1\xA0""CLOTHING TO KEEP\x80"\
			"\xE1\xA0""WARM\x80\x00";
	}
	else
	{
		msgData =
			"\x41\xA0""COLD WEATHER\x80"\
			"\x21\xA0""BRRRRRR\x80"\
			"\x01\xA0""YOU DO NOT HAVE\x80"\
			"\xF1\xA0""ENOUGH CLOTHING\x80"\
			"\xE1\xA0""TO KEEP WARM\x80\x00";

		C1 = 1;
	}

	ShowMsgOK(msgData);

	if (C1 == 0)
		return 0;

	return IllnessEvent();
}

int Events()
{
	unsigned int event = (unsigned int)Random();

	if (event < 15)
	{
		char* msgData =
			"\x41\xA0WAGON BREAKS DOWN\x80"\
			"\x21\xA0LOSE TIME AND\x80"\
			"\x11\xA0SUPPLIES FIXING IT\x80\x00";

		M = M - 15 - (((unsigned int)Random()) % 5);
		M1 = M1 - 8;

		ShowMsgOK(msgData);

		return 0;
	}

	if (event < 28)
	{
		char* msgData =
			"\x41\xA0OX INJURES LEG\x80"\
			"\x21\xA0SLOWS YOU DOWN\x80"\
			"\x11\xA0REST OF TRIP\x80\x00";

		M = M - 25;
		A = A - 20;

		ShowMsgOK(msgData);

		return 0;
	}

	if (event < 33)
	{
		char* msgData =
			"\x41\xA0""BAD LUCK\x80"\
			"\x21\xA0""YOUR DAUGHTER\x80"\
			"\x11\xA0""BROKE HER ARM\x80"\
			"\x01\xA0""YOU HAD TO STOP\x80"\
			"\xF1\xA0""AND USE SUPPLIES\x80"\
			"\xE1\xA0""TO MAKE A SLING\x80\x00";

		M = M - 5 - (((unsigned int)Random()) % 4);
		M1 = M1 - 2 - (((unsigned int)Random()) % 3);

		ShowMsgOK(msgData);

		return 0;
	}

	else if (event < 38)
	{
		char* msgData =
			"\x41\xA0""OX WANDERS OFF\x80"\
			"\x21\xA0""SPEND TIME\x80"\
			"\x11\xA0""LOOKING FOR IT\x80\x00";

		M = M - 17;

		ShowMsgOK(msgData);

		return 0;
	}

	if (event < 43)
	{
		char* msgData =
			"\x41\xA0""YOUR SON GETS LOST\x80"\
			"\x21\xA0""SPEND HALF THE\x80"\
			"\x11\xA0""DAY LOOKING\x80"\
			"\x01\xA0""FOR HIM\x80\x00";

		M = M - 10;

		ShowMsgOK(msgData);

		return 0;
	}

	if (event < 56)
	{
		char* msgData =
			"\x41\xA0""UNSAFE WATER\x80"\
			"\x21\xA0""LOSE TIME LOOKING\x80"\
			"\x11\xA0""FOR CLEAN SPRING\x80\x00";

		M = M - (((unsigned int)Random()) % 10) - 2;

		ShowMsgOK(msgData);

		return 0;
	}

	if (event < 82)
	{
		if (M > 950) return ColdWeatherEvent();

		char* msgData =
			"\x41\xA0""HEAVY RAINS\x80"\
			"\x21\xA0""TIME AND\x80"\
			"\x11\xA0""SUPPLIES LOST\x80\x00";

		F = F - 10;
		B = B - 500;
		M1 = M1 - 15;
		M = M - (((unsigned int)Random()) % 10) - 5;

		ShowMsgOK(msgData);

		return 0;
	}

	if (event < 89)
	{
		Shooting(-80, "BANDITS ATTACK\x80");

		B -= (20 * (long)B1);

		char* msgData;

		if (B < 0)
		{
			msgData =
				"\x41\xA0""YOU RAN OUT OF\x80"\
				"\x31\xA0""BULLETS. THEY GET\x80"\
				"\x21\xA0""LOTS OF CASH\x80\x00";

			T /= 3;
			B1 = 100;

			ShowMsgOK(msgData);
		}

		if (B1 > 1)
		{
			msgData =
				"\x41\xA0""YOU GOT SHOT IN\x80"\
				"\x31\xA0""THE LEG AND THEY\x80"\
				"\x21\xA0""TOOK ONE OF YOUR\x80"\
				"\x11\xA0""OXEN. BETTER HAVE\x80"\
				"\x01\xA0""A DOC LOOK AT\x80"\
				"\xF1\xA0""YOUR WOUND\x80\x00";

			K8 = 1;
			M1 -= 5;
			A -= 20;
		}
		else
		{
			msgData =
				"\x41\xA0""QUICKEST DRAW\x80"\
				"\x31\xA0""OUTSIDE OF DODGE\x80"\
				"\x21\xA0""CITY.\x80"\
				"\x11\xA0""YOU GOT EM\x80\x00";
		}

		ShowMsgOK(msgData);

		return 0;
	}

	if (event < 94)
	{
		char* msgData =
			"\x41\xA0""THERE WAS A FIRE\x80"\
			"\x31\xA0""IN YOUR WAGON\x80"\
			"\x11\xA0""FOOD AND SUPPLIES\x80"\
			"\x01\xA0""DAMAGED\x80\x00";

		F = F - 40;
		B = B - 400;
		M1 = M1 - (((unsigned int)Random()) % 8) - 3;
		M = M - 15;

		ShowMsgOK(msgData);

		return 0;
	}

	if (event < 107)
	{
		char* msgData =
			"\x41\xA0""LOSE YOUR WAY\x80"\
			"\x31\xA0""IN HEAVY FOG\x80"\
			"\x11\xA0""TIME IS LOST\x80\x00";

		M = M - 10 - (((unsigned int)Random()) % 5);

		ShowMsgOK(msgData);

		return 0;
	}

	if (event < 112)
	{
		char* msgData =
			"\x41\xA0""YOU KILLED A\x80"\
			"\x31\xA0""POISONOUS SNAKE\x80"\
			"\x21\xA0""AFTER IT BIT YOU\x80\x00";

		B = B - 10;
		M1 = M1 - 5;

		ShowMsgOK(msgData);

		if (M1 < 0)
		{
			return -5;
		}

		return 0;
	}

	if (event < 138)
	{
		char* msgData =
			"\x41\xA0""YOUR WAGON GETS\x80"\
			"\x31\xA0""SWAMPED FORDING\x80"\
			"\x21\xA0""RIVER\x80"\
			"\x01\xA0""LOSE FOOD\x80"\
			"\xF1\xA0""AND CLOTHES\x80\x00";

		F = F - 30;
		C = C - 20;
		M = M - 20 - (Random() % 20);

		ShowMsgOK(msgData);

		return 0;
	}

	if (event < 163)
	{
		Shooting(-110, "WILD ANIMALS ATTACK\x80");

		B -= (20 * (long)B1);

		char* msgData;

		if (B <= 39)
		{
			msgData =
				"\x41\xA0""YOU WERE TOO LOW\x80"\
				"\x31\xA0""ON BULLETS\x80"\
				"\x21\xA0""THE WOLVES\x80"\
				"\x11\xA0""OVERPOWERED YOU\x80\x00";

			K8 = 1;
		}
		else
		{
			if (B1 > 2)
			{
				msgData =
					"\x41\xA0""SLOW ON THE DRAW\x80"\
					"\x31\xA0""THEY GOT AT YOUR\x80"\
					"\x21\xA0""FOOD AND CLOTHES\x80\x00";
			}
			else
			{
				msgData =
					"\x41\xA0""NICE SHOOTING\x80"\
					"\x31\xA0""PARDNER\x80"\
					"\x21\xA0""THEY DID NOT\x80"\
					"\x11\xA0""GET MUCH\x80\x00";
			}

			B -= 20 * B1;
			C -= B1 * 4;
			F -= B1 * 8;
		}

		ShowMsgOK(msgData);

		if (K8)
		{
			return -6;
		}

		return ColdWeatherEvent();
	}

	if (event < 176)
	{
		char* msgData =
			"\x41\xA0""HAIL STORM\x80"\
			"\x21\xA0""SUPPLIES DAMAGED\x80\x00";

		M = M - 5 - (((unsigned int)Random()) % 10);
		B = B - 200;
		M1 = M1 - 4 - (((unsigned int)Random()) % 3);

		ShowMsgOK(msgData);

		return 0;
	}

	if (event < 242)
	{
		switch (E)
		{
		case 1: return IllnessEvent();
		case 3: if (((unsigned int)Random()) < 128) return IllnessEvent();
		default: if (((unsigned int)Random()) > 64) return IllnessEvent();
		}

		return 0;
	}

	{
		char* msgData =
			"\x41\xA0""HELPFUL NATIVE\x80"\
			"\x31\xA0""AMERICANS SHOW\x80"\
			"\x21\xA0""YOU WHERE TO \x80"\
			"\x11\xA0""FIND MORE FOOD\x80\x00";

		F += 14;

		ShowMsgOK(msgData);

		return 0;
	}
}

int Blizzard()
{
	char* msgData =
		"\x41\xA0""BLIZZARD IN\x80"\
		"\x31\xA0""MOUNTAIN PASS\x80"\
		"\x11\xA0""TIME AND\x80"\
		"\x01\xA0""SUPPLIES LOST\x80\x00";

	ShowMsgOK(msgData);

	L1 = 1;
	F -= 25;
	M1 -= 10;
	B -= 300;
	M -= 30 + 40 * (((unsigned int)Random()) % 40);

	if (C < 18 + 2 * (((unsigned int)Random()) % 2))
	{
		return IllnessEvent();
	}

	if (M <= 950)
	{
		M9 = 1;
	}

	return 0;
}

int Mountains()
{
	if (M < 1500)
	{
		if (((unsigned int)Random()) > 199 - M / 12)
		{
			return 0;
		}
	}
	else
	{
		if (((unsigned int)Random()) > 77 + ((M - 1500) / 8))
		{
			return 0;
		}
	}

	char* msgData;

	if (((unsigned int)Random()) <= 26)
	{
		msgData =
			"\x41\xA0""RUGGED MOUNTAINS\x80"\
			"\x21\xA0""YOU GOT LOST\x80"\
			"\x11\xA0""LOSE VALUABLE\x80"\
			"\x01\xA0""TIME TRYING TO\x80"\
			"\xF1\xA0""FIND TRAIL\x80\x00";
		M -= 60;
	}
	else if (((unsigned int)Random()) <= 28)
	{
		msgData =
			"\x41\xA0""RUGGED MOUNTAINS\x80"\
			"\x21\xA0""WAGON DAMAGED\x80"\
			"\x11\xA0""LOSE TIME\x80"\
			"\x01\xA0""AND SUPPLIES\x80\x00";

		M1 -= 5;
		B -= 200;
		M -= 20 + (((unsigned int)Random()) % 28);
	}
	else
	{
		msgData =
			"\x41\xA0""RUGGED MOUNTAINS\x80"\
			"\x21\xA0""THE GOING\x80"\
			"\x11\xA0""GETS SLOW\x80\x00";

		M -= 45 + (((unsigned int)Random()) / 5);
	}

	ShowMsgOK(msgData);

	if (F1 == 0)
	{
		F1 = 1;

		if (((unsigned int)Random()) < 204)
		{
			return Blizzard();
		}
		else
		{
			msgData =
				"\x41\xA0""YOU MADE IT\x80"\
				"\x31\xA0""SAFELY THROUGH\x80"\
				"\x21\xA0""SOUTH PASS\x80"\
				"\x11\xA0""NO SNOW\x80\x00";

			ShowMsgOK(msgData);
		}
	}

	if (M >= 1700)
	{
		if (F2 == 0)
		{
			F2 = 1;

			if (((unsigned int)Random()) < 179)
			{
				return Blizzard();
			}
		}
	}

	if (M <= 950)
	{
		M9 = 1;
	}

	return 0;
}

void Dying(int reason)
{
	char* msgData = 0;

	switch (reason)
	{
	case -1:
		msgData =
			"\x41\xA0""YOU RAN OUT OF\x80"\
			"\x31\xA0""FOOD AND STARVED\x80"\
			"\x21\xA0""TO DEATH\x80\x00";
		break;

	case -2:
		if (K8 == 0)
		{
			msgData =
				"\x41\xA0""YOU CAN NOT\x80"\
				"\x31\xA0""AFFORD A DOCTOR\x80"\
				"\x21\xA0""YOU DIED OF\x80"\
				"\x11\xA0""PNEUMONIA\x80\x00";
		}
		else
		{
			msgData =
				"\x41\xA0""YOU CAN NOT\x80"\
				"\x31\xA0""AFFORD A DOCTOR\x80"\
				"\x21\xA0""YOU DIED OF\x80"\
				"\x11\xA0""INJURIES\x80\x00";
		}
		break;

	case -3:
		if (K8 == 0)
		{
			msgData =
				"\x41\xA0""YOU RAN OUT OF\x80"\
				"\x31\xA0""MEDICAL SUPPLIES\x80"\
				"\x21\xA0""YOU DIED OF\x80"\
				"\x11\xA0""PNEUMONIA\x80\x00";
		}
		else
		{
			msgData =
				"\x41\xA0""YOU RAN OUT OF\x80"\
				"\x31\xA0""MEDICAL SUPPLIES\x80"\
				"\x21\xA0""YOU DIED OF\x80"\
				"\x11\xA0""INJURIES\x80\x00";
		}
		break;

	case -4:

		msgData =
			"\x41\xA0""YOU HAVE BEEN ON\x80"\
			"\x31\xA0""THE TRAIL TOO\x80"\
			"\x21\xA0""LONG YOUR FAMILY\x80"\
			"\x11\xA0""DIES IN THE \x80"\
			"\x01\xA0""FIRST BLIZZARD\x80"\
			"\xF1\xA0""OF WINTER\x80\x00";
		break;

	case -5:
		msgData =
			"\x41\xA0""YOU DIE OF\x80"\
			"\x31\xA0""SNAKEBITE SINCE\x80"\
			"\x21\xA0""YOU HAVE NO\x80"\
			"\x11\xA0""MEDICINE\x80\x00";
		break;

	case -6:
		if (K8 == 0)
		{
			msgData =
				"\x41\xA0""YOU DIED OF\x80"\
				"\x31\xA0""PNEUMONIA\x80\x00";
		}
		else
		{
			msgData =
				"\x41\xA0""YOU DIED OF\x80"\
				"\x31\xA0""INJURIES\x80\x00";
		}
		break;

	case -7:

		msgData =
			"\x41\xA0""YOU RAN OUT OF\x80"\
			"\x31\xA0""BULLETS AND GOT\x80"\
			"\x21\xA0""MASSACRED BY THE\x80"\
			"\x11\xA0""RIDERS\x80\x00";
		break;
	}

	if (msgData != 0)
	{
		ShowMsgOK(msgData);
	}

	msgData =
		"\x41\xA0""DUE TO YOUR\x80"\
		"\x31\xA0""UNFORTUNATE\x80"\
		"\x21\xA0""SITUATION, THERE\x80"\
		"\x11\xA0""ARE A FEW\x80"\
		"\x01\xA0""FORMALITIES\x80"\
		"\xF1\xA0""WE MUST GO\x80"\
		"\xE1\xA0""THROUGH\x80\x00";

	ShowMsgOK(msgData);

	msgData =
		"\x41\xA0""WOULD YOU LIKE A\x80"\
		"\x31\xA0""MINISTER?\x80\x00";

	ShowMsgYesNo(msgData);

	msgData =
		"\x41\xA0""WOULD YOU LIKE A\x80"\
		"\x31\xA0""FANCY FUNERAL?\x80\x00";

	ShowMsgYesNo(msgData);

	msgData =
		"\x41\xA0""WOULD YOU LIKE US\x80"\
		"\x31\xA0""TO INFORM YOUR\x80"\
		"\x21\xA0""NEXT OF KIN?\x80\x00";

	int sendTelegram = ShowMsgYesNo(msgData);

	if (sendTelegram)
	{
		msgData =
			"\x41\xA0""THAT WILL BE\x80"\
			"\x31\xA0""$4.50 FOR THE\x80"\
			"\x21\xA0""TELEGRAPH CHARGE\x80\x00";
	}
	else
	{
		msgData =
			"\x41\xA0""BUT YOUR AUNT\x80"\
			"\x31\xA0""SADIE IN\x80"\
			"\x21\xA0""ST. LOUIS IS\x80"\
			"\x11\xA0""REALLY WORRIED\x80"\
			"\x01\xA0""ABOUT YOU\x80\x00";
	}

	ShowMsgOK(msgData);

	msgData =
		"\x61\xA0""WE THANK YOU FOR\x80"\
		"\x51\xA0""THIS INFORMATION\x80"\
		"\x41\xA0""AND WE ARE SORRY\x80"\
		"\x31\xA0""YOU DID NOT MAKE\x80"\
		"\x21\xA0""IT TO THE GREAT\x80"\
		"\x11\xA0""TERRITORY OF\x80"\
		"\x01\xA0""OREGON BETTER\x80"\
		"\xF1\xA0""LUCK NEXT TIME\x80"\
		"\xD1\xA0""SINCERELY\x80"\
		"\xC1\xA0""THE OREGON CITY\x80"\
		"\xB1\xA0""CHAMBER OF\x80"\
		"\xA1\xA0""COMMERCE\x80\x00";

	ShowMsgOK(msgData);
}

void LastTurn()
{
	char finalDay[] = { 'D', 'D', 'D', ' ', 'M', 'M', 'M', ' ','N','N',' ','1','8','4','7',0x80 };

	daystr = finalDay;

	long F9 = ((2040 - M2) * 14) / (M - M2);
	F += ((long)(14 - F9) * (long)(8 + 5 * E)) / 14;
	long totalDays = (long)D3;
	totalDays = totalDays * 14 + F9;

	F9++;

	if (F9 >= 8)
	{
		F9 -= 7;
	}

	switch (F9)
	{
		case 0: finalDay[0] = 'M'; finalDay[1] = 'O'; finalDay[2] = 'N'; break;
		case 1: finalDay[0] = 'T'; finalDay[1] = 'U'; finalDay[2] = 'E'; break;
		case 2: finalDay[0] = 'W'; finalDay[1] = 'E'; finalDay[2] = 'D'; break;
		case 3: finalDay[0] = 'T'; finalDay[1] = 'H'; finalDay[2] = 'U'; break;
		case 4: finalDay[0] = 'F'; finalDay[1] = 'R'; finalDay[2] = 'I'; break;
		case 5: finalDay[0] = 'S'; finalDay[1] = 'A'; finalDay[2] = 'T'; break;
		case 6: finalDay[0] = 'S'; finalDay[1] = 'O'; finalDay[2] = 'N'; break;
	}

	if (totalDays <= (long)124)
	{
		totalDays -= 93;
		finalDay[4] = 'J'; finalDay[5] = 'U'; finalDay[6] = 'L';
	}
	else if (totalDays <= (long)155)
	{
		totalDays -= 124;
		finalDay[4] = 'A'; finalDay[5] = 'U'; finalDay[6] = 'G';
	}
	else if (totalDays <= (long)185)
	{
		totalDays -= 155;
		finalDay[4] = 'S'; finalDay[5] = 'E'; finalDay[6] = 'P';
	}
	else if (totalDays <= (long)216)
	{
		totalDays -= 185;
		finalDay[4] = 'O'; finalDay[5] = 'C'; finalDay[6] = 'T';
	}
	else if (totalDays <= (long)246)
	{
		totalDays -= 216;
		finalDay[4] = 'N'; finalDay[5] = 'O'; finalDay[6] = 'V';
	}
	else
	{
		totalDays -= 246;
		finalDay[4] = 'D'; finalDay[5] = 'E'; finalDay[6] = 'C';
	}

	Format3(&finalDay[7], totalDays);

	char* msgData =
		"\x41\xA0""YOU FINALLY\x80"\
		"\x31\xA0""ARRIVED AT\x80"\
		"\x21\xA0""OREGON CITY\x80"\
		"\x11\xA0""AFTER 2040\x80"\
		"\x01\xA0""LONG MILES\x80"\
		"\xE1\xA0""HOORAY\x80"\
		"\xC1\xA0""A REAL PIONEER\x80\x00";

	ShowMsgOK(msgData);

	if (B < 0)
	{
		B = 0;
	}

	if (C < 0)
	{
		C = 0;
	}

	if (M1 < 0)
	{
		M1 = 0;
	}

	if (T < 0)
	{
		T = 0;
	}

	if (F < 0)
	{
		F = 0;
	}

	char cash[6] = { '$', ' ', ' ', ' ', ' ', 0x80 };
	char food[6] = { 'F', ' ', ' ', ' ', ' ', 0x80 };
	char ammo[8] = { 'A', ' ',' ',' ',' ' , ' ', ' ', 0x80 };
	char cloth[6] = { 'C', ' ', ' ', ' ', ' ', 0x80 };
	char supp[6] = { 'S', ' ', ' ', ' ', ' ', 0x80 };

	Format3(&cash[2], T);
	Format3(&food[2], F);
	Format5(&ammo[2], B);
	Format3(&cloth[2], C);
	Format3(&supp[2], M1);

	while (1)
	{
		StartFrame ();
		Print_Str_d(110, -100, "YOU HAVE LEFT\x80");
		Print_Str_d(70, -100, cash);
		Print_Str_d(10, -100, food);
		Print_Str_d(-10, -100, ammo);
		Print_Str_d(-30, -100, cloth);
		Print_Str_d(-50, -100, supp);

		Print_Str_d(BOTTOM, 90, "OK\x80");

		Read_Btns();

		if (Vec_Button_1_4 != 0)
		{
			break;
		}
	}

	msgData =
		"\x41\xA0""PRESIDENT\x80"\
		"\x31\xA0""JAMES K. POLK\x80"\
		"\x21\xA0""SENDS YOU HIS\x80"\
		"\x11\xA0""HEARTIEST\x80"\
		"\x01\xA0""CONGRATULATIONS\x80"\
		"\xF1\xA0""AND WISHES YOU A\x80"\
		"\xE1\xA0""PROSPEROUS LIFE\x80"\
		"\xD1\xA0""AHEAD AT YOUR\x80"\
		"\xC1\xA0""NEW HOME\x80\x00";

	ShowMsgOK(msgData);
}

int main(void)
{
	Vec_Joy_Mux_1_X = 1;
	Vec_Joy_Mux_1_Y = 3;
	Vec_Joy_Mux_2_X = 0;
	Vec_Joy_Mux_2_Y = 0;

	if (InstructionQuestion() == 1)
	{
		ShowInstruction();
	}

	D9 = SelectLevel();

	InitialPurchases();

	while (1)
	{
		if (M >= 2040)
		{
			LastTurn();
			return 0;
		}

		if (SetDayString() == 0)
		{
			Dying(-4);
			return 0;
		};

		switch (StartTurn())
		{
		case 1:
			StoppingAtFort();
			break;

		case 2:
			Hunting();
			break;

		case 3:
			break;

		default:
			return 0;
		}

		if (F < 13)
		{
			Dying(-1);
			return 0;
		}

		Eating();

		M = M + 200 + (A - 220) / 5 + (((unsigned int)Random()) % 10);
		L1 = 0;
		C1 = 0;

		int attackResult = RidersAttack();

		if (attackResult < 0)
		{
			Dying(attackResult);
			return 0;
		}

		int eventResult = Events();

		if (eventResult < 0)
		{
			Dying(eventResult);
			return 0;
		}

		if (M > 950)
		{
			int mountainsResult = Mountains();

			if (mountainsResult < 0)
			{
				Dying(mountainsResult);
				return 0;
			}
		}
	}
}
